import { ConditionGroupType, NumberCondition, StringCondition, DateCondition, OrderByDirections } from '../tools/databasetool.interfaces';
import { SelectWizard } from '../tools/select.class';
export declare enum MessageFields {
    id = "id",
    user = "user",
    account = "account",
    date_created = "date_created",
    date_sent = "date_sent",
    sent_to = "sent_to",
    sent_from = "sent_from",
    body = "body",
    ourNumber = "ourNumber",
    theirNumber = "theirNumber"
}
interface MessageSelectQuery {
    fields: Array<MessageFields>;
    where: MessageConditionGroup | MessageCondition;
}
interface MessageConditionGroup {
    type: ConditionGroupType;
    conditions: Array<MessageConditionGroup | MessageCondition> | MessageCondition;
}
interface MessageCondition {
    id?: number | NumberCondition;
    user?: number | NumberCondition;
    account?: number | NumberCondition;
    date_created?: Date | DateCondition;
    date_sent?: Date | DateCondition;
    sent_to?: String | StringCondition;
    sent_from?: String | StringCondition;
    body?: String | StringCondition;
    ourNumber?: String | StringCondition;
    theirNumber?: String | StringCondition;
    someCustom?: any;
}
interface MessageSelectQuery {
    fields: Array<MessageFields>;
    where: MessageConditionGroup | MessageCondition;
    limit?: number;
    orderBy?: MessageSelectOrderBy;
    groupBy?: string;
}
interface MessageSelectOrderBy {
    field: MessageFields;
    direction: OrderByDirections;
}
export declare function MessageSelect(messageSelect: MessageSelectQuery): SelectWizard;
export {};
