import { ConditionGroupType, NumberCondition, StringCondition, DateCondition, OrderByDirections } from '../tools/databasetool.interfaces';
declare enum CouponsFields {
    star = "*",
    id = "id",
    code = "code",
    off = "off",
    status = "status",
    created_at = "created_at",
    offType = "offType"
}
interface CouponsCondition {
    id?: number | NumberCondition;
    code?: String | StringCondition;
    off?: number | NumberCondition;
    status?: number | NumberCondition;
    created_at?: Date | DateCondition;
    offType?: String | StringCondition;
}
interface CouponsConditionGroup {
    type: ConditionGroupType;
    conditions: Array<CouponsConditionGroup | CouponsCondition> | CouponsCondition;
}
interface CouponsSelectOrderBy {
    field: CouponsFields;
    direction: OrderByDirections;
}
interface CouponsSelectGroupBy {
    field: CouponsFields;
}
interface CouponsInterface {
    id?: number;
    code?: string;
    off?: string;
    status?: string;
    offType?: string;
    created_at?: Date | string;
}
export default class CouponsClass {
    fields: typeof CouponsFields;
    new(Coupons?: CouponsInterface): CouponsInstance;
    select(CouponsSelect: {
        fields: Array<CouponsFields>;
        where: CouponsConditionGroup | CouponsCondition;
        limit?: number;
        orderBy?: CouponsSelectOrderBy;
        groupBy?: CouponsSelectGroupBy;
    }): Promise<Array<any>>;
    upsert(Coupons: CouponsInterface | CouponsInstance | Array<CouponsInterface | CouponsInstance>): Promise<any>;
    delete(Coupons: CouponsInterface | CouponsInstance | Array<CouponsInterface | CouponsInstance>): Promise<any>;
    findById(id: number): Promise<any>;
}
declare class CouponsInstance {
    readonly isCouponsInstance: boolean;
    constructor(Coupons?: CouponsInterface);
    private instance;
    id: number;
    code: string;
    off: string;
    status: string;
    offType: string;
    created_at: Date | string;
    save(): Promise<any>;
    delete(): Promise<any>;
}
export {};
