"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const databasetool_interfaces_1 = require("../tools/databasetool.interfaces");
const select_helper_class_1 = require("../tools/select.helper.class");
const instance_class_1 = require("../tools/instance.class");
var CouponsFields;
(function (CouponsFields) {
    CouponsFields["star"] = "*";
    CouponsFields["id"] = "id";
    CouponsFields["code"] = "code";
    CouponsFields["off"] = "off";
    CouponsFields["status"] = "status";
    CouponsFields["created_at"] = "created_at";
    CouponsFields["offType"] = "offType";
})(CouponsFields || (CouponsFields = {}));
let primary_key = CouponsFields.id;
let customFunctions = {
    someCustom: (input) => {
        return {
            field: 'id',
            type: databasetool_interfaces_1.ConditionType.gt,
            value: input + ' AND THRN SOME'
        };
    }
};
class CouponsClass {
    constructor() {
        this.fields = CouponsFields;
    }
    new(Coupons) {
        return new CouponsInstance(Coupons);
    }
    select(CouponsSelect) {
        return __awaiter(this, void 0, void 0, function* () {
            let genericSelect = CouponsSelect;
            if (!genericSelect.fields.includes(primary_key))
                CouponsSelect.fields.push(primary_key);
            let tableHelper = new select_helper_class_1.ConvertSpecificTableSelectIntoGeneralSelectWizard({ base: 'Coupons', customGroup: genericSelect, CustomProperties: customFunctions });
            let anyGenericResults = yield tableHelper.returnTable().execute();
            let arrayOfGenericResults = anyGenericResults;
            let arrayOfInstances = arrayOfGenericResults.map(l => new CouponsInstance(l));
            return arrayOfInstances;
        });
    }
    upsert(Coupons) {
        return __awaiter(this, void 0, void 0, function* () {
            let save = (single) => {
                if (single.isCouponsInstance)
                    return single.save();
                else
                    return new CouponsInstance(single).save();
            };
            if (Array.isArray(Coupons)) {
                return Promise.all(Coupons.map(el => save(el)));
            }
            else {
                return save(Coupons);
            }
        });
    }
    delete(Coupons) {
        return __awaiter(this, void 0, void 0, function* () {
            let remove = (single) => {
                if (single.isCouponsInstance)
                    return single.delete();
                else
                    return new CouponsInstance(single).delete();
            };
            if (Array.isArray(Coupons)) {
                return Promise.all(Coupons.map(el => remove(el)));
            }
            else {
                return remove(Coupons);
            }
        });
    }
    //Only shown if the primary key is a number
    findById(id) {
        return __awaiter(this, void 0, void 0, function* () {
            let newCondition = {};
            newCondition[primary_key] = id;
            newCondition;
            let resultOffind = yield this.select({
                fields: [CouponsFields.star],
                where: newCondition
            });
            if (resultOffind.length && resultOffind.length === 1)
                return resultOffind[0];
            else
                return {
                    error: "Should have returned an array with exactly 1 result, however it did not. please see the results property",
                    results: resultOffind
                };
        });
    }
}
exports.default = CouponsClass;
class CouponsInstance {
    constructor(Coupons) {
        this.isCouponsInstance = true;
        if (!Coupons)
            Coupons = {};
        let genericObj = Coupons;
        this.instance = new instance_class_1.InstanceWizard({ table: 'Coupons', primary_key: 'id', fields: genericObj });
    }
    get id() { return this.instance.fields['id']; }
    set id(val) {
        if (this.instance.isNew) {
            this.instance.fields['id'] = val;
        }
        else {
            console.log('YOU CAN NOT CHANGE THE PRIMARY KEY OF AN EXISTING ROW');
        }
    }
    get code() {
        return this.instance.fields['code'];
    }
    get off() {
        return this.instance.fields['off'];
    }
    get status() {
        return this.instance.fields['status'];
    }
    get offType() {
        return this.instance.fields['offType'];
    }
    get created_at() {
        return this.instance.fields['created_at'];
    }
    set code(val) {
        this.instance.fields['code'] = val;
    }
    set off(val) {
        this.instance.fields['off'] = val;
    }
    set status(val) {
        this.instance.fields['status'] = val;
    }
    set offType(val) {
        this.instance.fields['offType'] = val;
    }
    set created_at(val) {
        this.instance.fields['created_at'] = val;
    }
    save() {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.instance.save();
        });
    }
    delete() {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.instance.delete();
        });
    }
}
//# sourceMappingURL=coupon.example.class.js.map