"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const coupon_example_class_1 = __importDefault(require("./coupon.example.class"));
const databasetool_interfaces_1 = require("../tools/databasetool.interfaces");
describe("It should have all the functionalities required", () => {
    let coupons = new coupon_example_class_1.default();
    it("Should create the Coupons Class", () => {
        expect(coupons).toBeTruthy();
        expect(coupons).toHaveProperty('new');
        expect(coupons).toHaveProperty('select');
        expect(coupons).toHaveProperty('upsert');
        expect(coupons).toHaveProperty('delete');
    });
    //Success
    xit("Should be able to select", () => __awaiter(this, void 0, void 0, function* () {
        let selectResults = yield coupons.select({
            fields: [
                coupons.fields.id,
                coupons.fields.offType,
                coupons.fields.code
            ], where: {
                id: {
                    type: databasetool_interfaces_1.NumberConditionType.gt,
                    value: 1
                }
            },
            limit: 2
        });
        expect(selectResults[0].code).toEqual("chesterlaw");
        expect(selectResults[0].id).toEqual(2);
        expect(selectResults[0].offType).toEqual("fixed");
        expect(selectResults[1].code).toEqual("Doesn't matter what is in this field");
        expect(selectResults[1].id).toEqual(9);
    }));
    //success
    xit("Should be able to change and save one of the selected", () => __awaiter(this, void 0, void 0, function* () {
        let selectResults = yield coupons.select({
            fields: [
                coupons.fields.id,
                coupons.fields.offType,
                coupons.fields.code
            ], where: {
                id: {
                    type: databasetool_interfaces_1.NumberConditionType.gt,
                    value: 1
                }
            },
            limit: 2
        });
        let randomCoupon = selectResults[1];
        let randomStringValue = "Rando" + Math.round(Math.random() * 1000);
        randomCoupon.offType = randomStringValue;
        yield randomCoupon.save();
        let returnNewInstanceOfRandomCoupon = yield coupons.findById(randomCoupon.id);
        expect(returnNewInstanceOfRandomCoupon.offType).toEqual(randomStringValue);
    }));
    //Success
    xit("Should always pull the primary key, regardless of user request", () => __awaiter(this, void 0, void 0, function* () {
        let selectResults = yield coupons.select({
            fields: [
                coupons.fields.offType,
                coupons.fields.code
            ], where: {
                id: {
                    type: databasetool_interfaces_1.NumberConditionType.gt,
                    value: 1
                }
            },
            limit: 2
        });
        expect(selectResults[0]).toHaveProperty('id');
    }));
    //success
    xit("Should be able to use the findById property", () => __awaiter(this, void 0, void 0, function* () {
        let coupon = yield coupons.findById(9);
        expect(coupon).toEqual({ "code": "Doesn't matter what is in this field", "id": 9, "offType": null, "created_at": new Date("2018-08-17T18:52:49.000Z"), "status": 1, "off": null });
    }));
    //Success
    xit("Should be able to insert a new coupon and save, when saving, the id should be added to the saved object", () => __awaiter(this, void 0, void 0, function* () {
        let coupon = coupons.new({ offType: "New OT", code: "Rando" + Math.round(Math.random() * 1000) });
        expect(coupon.id).toBeFalsy();
        yield coupon.save();
        expect(coupon.id).toBeGreaterThan(1);
        console.log(coupon);
    }));
    //Success
    xit("Should delete from the coupons class", () => __awaiter(this, void 0, void 0, function* () {
        let coupon = coupons.new({ offType: "New OT", code: "Rando" + Math.round(Math.random() * 1000) });
        expect(coupon.id).toBeFalsy();
        yield coupon.save();
        expect(coupon.id).toBeGreaterThan(1);
        let res = yield coupons.delete({ id: coupon.id });
        expect(res.affectedRows).toEqual(1);
    }));
    //Success
    xit("Should delete from the instance", () => __awaiter(this, void 0, void 0, function* () {
        let coupon = coupons.new({ offType: "New OT", code: "Rando" + Math.round(Math.random() * 1000) });
        expect(coupon.id).toBeFalsy();
        yield coupon.save();
        expect(coupon.id).toBeGreaterThan(1);
        let res = yield coupon.delete();
        expect(res.affectedRows).toEqual(1);
    }));
});
//# sourceMappingURL=coupon.test.js.map