"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class MasterCreator {
    constructor(tableNames) {
        this.tableNames = tableNames;
        this.importsArray = [];
        this.classDeclarationsArray = [];
        tableNames.forEach(table => {
            this.addImport(table);
            this.addClassDeclaration(table);
        });
    }
    importString(table) { return `import ${table} from './tables/${table}.class'`; }
    classDeclarationString(table) { return `static ${table} = new ${table}()`; }
    addImport(table) { this.importsArray.push(this.importString(table)); }
    addClassDeclaration(table) { this.classDeclarationsArray.push(this.classDeclarationString(table)); }
    joinEm(ar) {
        return ar.join(`
    `);
    }
    get fullPage() {
        return `
${this.joinEm(this.importsArray)}

export default class master {
    ${this.joinEm(this.classDeclarationsArray)}
}

        `;
    }
}
exports.default = MasterCreator;
//# sourceMappingURL=master.creator.class.js.map