"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const instance_class_1 = require("../tools/instance.class");
describe("Should create insert and update queries", () => {
    let testOne = new instance_class_1.InstanceWizard({
        table: 'coupons', fields: {
            id: 5,
            code: 'CHANGED CODE',
            offType: 'CHANGED ALSO'
        }, primary_key: 'id'
    });
    it("Should create update", () => {
        expect(testOne.queryString).toBe("UPDATE coupons  SET ? WHERE id = 5");
    });
    let testTwo = new instance_class_1.InstanceWizard({
        table: 'coupons', fields: {
            code: 'FAKE',
            offType: 'Percentage'
        }, primary_key: 'id'
    });
    it("Should create insert", () => {
        expect(testTwo.queryString).toBe("INSERT INTO coupons SET ?");
    });
    //Executes successfully but you can't run this every time because the return object always changes
    xit("Should actually insert a coupon", () => __awaiter(this, void 0, void 0, function* () {
        let res = yield testTwo.save();
        expect(res).toEqual({ "affectedRows": 1, "changedRows": 0, "fieldCount": 0, "insertId": 4, "message": "", "protocol41": true, "serverStatus": 2, "warningCount": 0 });
    }));
    //Executes successfully but you can't run this every time because the return object always changes
    xit("Should change the code to CHANGED CODE", () => __awaiter(this, void 0, void 0, function* () {
        let resp = yield testOne.save();
        expect(resp).toEqual({ "affectedRows": 1, "changedRows": 1, "fieldCount": 0, "insertId": 0, "message": "(Rows matched: 1  Changed: 1  Warnings: 0", "protocol41": true, "serverStatus": 2, "warningCount": 0 });
    }));
});
//# sourceMappingURL=instance.test.js.map