export interface SelectWizardProperties {
    base: String;
    fields: Array<String>;
    where: ConditionGroup | Condition;
    limit?: number;
    orderBy?: GenericOrderBy;
    groupBy?: string;
}
export interface SelectQuery {
    fields: Array<String>;
    where: ConditionGroup | Condition;
}
export declare enum ConditionGroupType {
    and = "AND",
    or = "OR"
}
export interface Condition {
    field: String;
    type: ConditionType;
    value: String | number | Date | Array<String | number | Date>;
}
export declare enum ConditionType {
    equals = " = ",
    gt = " > ",
    lt = " < ",
    gtoe = " >= ",
    ltoe = " <= ",
    like = " like ",
    between = " between "
}
export interface ConditionGroup {
    type: ConditionGroupType;
    conditions: Array<ConditionGroup | Condition>;
}
export interface SelectTableMakerFunction {
    (base: string, select: Function): SelectWizardProperties;
}
export declare enum NumberConditionType {
    equals = " = ",
    gt = " > ",
    lt = " < ",
    gtoe = " >= ",
    ltoe = " <= "
}
export declare enum StringConditionType {
    equals = " = ",
    like = " like "
}
export declare enum DateConditionType {
    equals = " = ",
    gt = " > ",
    lt = " < ",
    gtoe = " >= ",
    ltoe = " <= ",
    between = " between "
}
export interface NumberCondition {
    type: NumberConditionType;
    value: String | number | Date;
}
export interface StringCondition {
    type: StringConditionType;
    value: String;
}
export interface DateCondition {
    type: StringConditionType;
    value: String | Date | Array<String | number | Date>;
}
export interface GenericSelectQuery {
    fields: Array<string>;
    where: any;
    limit?: number;
    orderBy?: GenericOrderBy;
    groupBy?: string;
}
export interface GenericOrderBy {
    field: String;
    direction: OrderByDirections;
}
export declare enum OrderByDirections {
    asc = " asc ",
    desc = " desc "
}
