"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const access_1 = require("./access");
class InstanceWizard {
    constructor(options) {
        this.table = options.table;
        this.fields = options.fields;
        this.primary_key = options.primary_key;
    }
    get isNew() {
        return this.primary_key_value ? false : true;
    }
    get isUpdate() {
        return this.primary_key_value ? true : false;
    }
    get primary_key_value() {
        return this.fields[this.primary_key];
    }
    get queryString() {
        if (this.isNew)
            return this.createInsertString();
        else if (this.isUpdate)
            return this.createUpdateString();
        else
            return "IT SHOULD NOT BE POSSIBLE TO REACH THIS";
    }
    createInsertString() {
        return `INSERT INTO ${this.table} SET ?`;
    }
    createUpdateString() {
        return `UPDATE ${this.table}  SET ? WHERE ${this.primary_key} = ${access_1.db.escape(this.primary_key_value)}`;
    }
    createDeleteString() {
        return `DELETE FROM ${this.table} WHERE ${this.primary_key} = ${access_1.db.escape(this.primary_key_value)}`;
    }
    save() {
        return __awaiter(this, void 0, void 0, function* () {
            let resultFromSave = yield access_1.query(this.queryString, this.fields);
            if (resultFromSave.insertId)
                this.fields[this.primary_key] = resultFromSave.insertId;
            return resultFromSave;
        });
    }
    delete() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.isNew)
                return console.log("There is no primary key value so you can not delete this item");
            return yield access_1.query(this.createDeleteString());
        });
    }
}
exports.InstanceWizard = InstanceWizard;
//# sourceMappingURL=instance.class.js.map