export default class MasterCreator {

    constructor(private tableNames: Array<string>) {

        tableNames.forEach(table => {
            this.addImport(table)
            this.addClassDeclaration(table)
        })
    }

    importString(table: string): string { return `import ${table} from './tables/${table}.class'` }
    classDeclarationString(table: string): string { return `static ${table} = new ${table}()` }
    addImport(table: string): void { this.importsArray.push(this.importString(table)) }
    addClassDeclaration(table: string): void { this.classDeclarationsArray.push(this.classDeclarationString(table)) }
    importsArray: Array<string> = []
    classDeclarationsArray: Array<string> = []

    joinEm(ar: Array<string>) {
        return ar.join(`
    `)
    }

    get fullPage(): string {
        return `
${this.joinEm(this.importsArray)}

export default class master {
    ${this.joinEm(this.classDeclarationsArray)}
}

        `
    }


}