import { InstanceWizard } from '../tools/instance.class'

describe("Should create insert and update queries", () => {
    let testOne = new InstanceWizard({
        table: 'coupons', fields: {
            id: 5,
            code: 'CHANGED CODE',
            offType: 'CHANGED ALSO'
        }, primary_key: 'id'
    })

    it("Should create update", () => {
        expect(testOne.queryString).toBe("UPDATE coupons  SET ? WHERE id = 5")
    })

    let testTwo = new InstanceWizard({
        table: 'coupons', fields: {
            code: 'FAKE',
            offType: 'Percentage'
        }, primary_key: 'id'
    })


    it("Should create insert", () => {
        expect(testTwo.queryString).toBe("INSERT INTO coupons SET ?")
    })

    //Executes successfully but you can't run this every time because the return object always changes
    xit("Should actually insert a coupon", async () => {
        let res = await testTwo.save()
        expect(res).toEqual({ "affectedRows": 1, "changedRows": 0, "fieldCount": 0, "insertId": 4, "message": "", "protocol41": true, "serverStatus": 2, "warningCount": 0 })
    })

    //Executes successfully but you can't run this every time because the return object always changes
    xit("Should change the code to CHANGED CODE", async () => {
        let resp = await testOne.save()
        expect(resp).toEqual({ "affectedRows": 1, "changedRows": 1, "fieldCount": 0, "insertId": 0, "message": "(Rows matched: 1  Changed: 1  Warnings: 0", "protocol41": true, "serverStatus": 2, "warningCount": 0 })
    })
})