import * as mysql from "mysql";
import dotenv from 'dotenv'
dotenv.config({ path: '.env' })

export const db = mysql.createPool({
    connectionLimit: 2,
    host: process.env.DB_HOST,
    user: process.env.DB_USER,
    password: process.env.DB_PASSWORD,
    database: process.env.DB_NAME,
    multipleStatements: true,
    charset: 'utf8mb4'
})


export let query = async (q: string, parameters?: any) => {
    return new Promise((resolve, reject) => {
        db.query(q, parameters, (error: any, response: any) => {
            if (!error) {
                resolve(response)
            } else {
                reject(error);
            }
        })
    })
}

