import { query, db } from './access'


export class InstanceWizard {
    constructor(options: { table: string, fields: any, primary_key: string }) {
        this.table = options.table
        this.fields = options.fields
        this.primary_key = options.primary_key
    }
    private table: string
    fields: any
    primary_key: string
    get isNew(): boolean {
        return this.primary_key_value ? false : true
    }

    get isUpdate(): boolean {
        return this.primary_key_value ? true : false
    }

    get primary_key_value(): any {
        return this.fields[this.primary_key]
    }

    get queryString(): string {
        if (this.isNew)
            return this.createInsertString()
        else if (this.isUpdate)
            return this.createUpdateString()
        else
            return "IT SHOULD NOT BE POSSIBLE TO REACH THIS"
    }

    createInsertString(): string {
        return `INSERT INTO ${this.table} SET ?`
    }

    createUpdateString(): string {
        return `UPDATE ${this.table}  SET ? WHERE ${this.primary_key} = ${db.escape(this.primary_key_value)}`
    }

    createDeleteString(): string {
        return `DELETE FROM ${this.table} WHERE ${this.primary_key} = ${db.escape(this.primary_key_value)}`
    }

    async save() {
        let resultFromSave: any = await query(this.queryString, this.fields)
        if (resultFromSave.insertId) this.fields[this.primary_key] = resultFromSave.insertId
        return resultFromSave
    }

    async delete() {
        if (this.isNew) return console.log("There is no primary key value so you can not delete this item")
        return await query(this.createDeleteString())
    }
}